#include <stdio.h>
#include <string.h>
#include "geometry.h"
#include "directionalLight.h"
#include "math.h"
#include "implemented.h"

int DirectionalLight::read(FILE* fp){
  if (fscanf(fp," %lg %lg %lg %lg %lg %lg",
	     &(color[0]),&(color[1]),&(color[2]),
	     &(direction[0]),&(direction[1]),&(direction[2])
	     ) != 6){return 0;}
  direction=direction.unit();
  return 1;
}
void DirectionalLight::write(FILE* fp){
  fprintf(fp,"#light_dir\n");
  fprintf(fp,"  %lg %lg %lg\n",color[0],color[1],color[2]);
  fprintf(fp,"  %lg %lg %lg\n",direction[0],direction[1],direction[2]);
}

Point3D DirectionalLight::getDiffuse(Point3D cameraPosition,
				     IntersectionInfo iInfo){
  if(implementedFlag){
    printf("The DirectionalLight::getDiffuse(Point3D cameraPosition,IntersectionInfoiInfo) method has not been implemented\n");
  }
  return Point3D();
}
Point3D DirectionalLight::getSpecular(Point3D cameraPosition,
				      IntersectionInfo iInfo){
  if(implementedFlag){
    printf("The DirectionalLight::getSpecular(Point3D cameraPosition,IntersectionInfo iInfo) method has not been implemented\n");
  }
  return Point3D();
}
int DirectionalLight::isInShadow(IntersectionInfo iInfo,Shape* shape){
  if(implementedFlag){
    printf("The DirectionalLight::isInShadow(IntersectionInfo iInfo,Shape* shape) method has not been implemented\n");
  }
  return 0;
}

