#include <stdio.h>
#include <stdlib.h>
#include "triangle.h"
#include "implemented.h"

Triangle::Triangle(FILE* fp,int* index,Vertex* vList,int vSize){
  int v1,v2,v3;
  if(fscanf(fp," %d %d %d %d",index,&v1,&v2,&v3) != 4){
    fprintf(stderr, "Failed to parse shape_triangle for Triangle\n"); 
    exit(EXIT_FAILURE);
  }
  if(v1<0 || v1>=vSize || v2<0 || v2>=vSize || v3<0 || v3>=vSize){
    fprintf(stderr, "Vertex index not within bounds for Triangle\n");
    exit(EXIT_FAILURE);
  }
  if(v1==v2 || v1==v3 || v2==v3){
    fprintf(stderr,"Vertices must be distinct in Triangle\n");
    exit(EXIT_FAILURE);
  }
  v[0]=&(vList[v1]);
  v[1]=&(vList[v2]);
  v[2]=&(vList[v3]);
}
void  Triangle::write(int indent,FILE* fp){
  int i;
  for(i=0;i<indent;i++){fprintf(fp," ");}
  fprintf(fp,"#shape_triangle %d\n",material->index);
  for(i=0;i<indent;i++){fprintf(fp," ");}
  fprintf(fp,"  %d %d %d\n",v[0]->index,v[1]->index,v[2]->index);
}
char* Triangle::name(void){return "triangle";}
Flt Triangle::intersect(Ray ray,IntersectionInfo& iInfo){
  if(implementedFlag){
    printf("The Triangle::intersect(Ray ray,IntersectionInfo& iInfo) method has not been implemented\n");
  }
  return -1.0;
}
BoundingBox Triangle::getBoundingBox(void){
  if(implementedFlag){
    printf("The Triangle::getBoundingBox(void) method has not been implemented\n");
  }
  return BoundingBox();
}

